︠3c39f3d8-e058-4254-a670-8ce5a07ba5efi︠
%md
## Le rotationnel d'un champ de vecteurs
Définition : Étant donné un champ de vecteurs $\mathbf{F}=P\mathbf{e}_1+Q\mathbf{e}_2+R\mathbf{e}_3$, son rotationnel est le champ de vecteurs $${\rm rot}\mathbf{F} = \nabla \times\mathbf{F} = \left(\frac{\partial R }{\partial y} - \frac{\partial Q }{\partial z }  \right)\mathbf{e}_1 + \left(\frac{\partial P }{\partial z} - \frac{\partial R}{\partial x}  \right) \mathbf{e}_2+ \left(\frac{\partial Q}{\partial x} - \frac{\partial P}{\partial y}  \right)\mathbf{e}_3$$

La signification physique du champ rotationnel est la mesure que $\mathbf{F}$ aurait à faire tourner des particules, s'il était un champ de vitesses : si $\mathbf{u}$ est un vecteur donné, le produit scalaire ${\rm rot}\mathbf{F}\cdot\mathbf{u}$ au point $(x_0,y_0,z_0)$ est la mesure de la tendence à faire des tourbillons autour de l'axe de rotation passant par $(x_0,y_0,z_0)$ de direction $\mathbf{u}$.  En 3D il est (un peu)  compliqué de visualiser les choses, il convient de commencer par des champs $\mathbf{F}=P\mathbf{e}_1+Q\mathbf{e}_2$, c'est à dire en faisant $R=0$, et $P=P(x,y), Q=Q(x,y)$. Ainsi, seule la coposante $\mathbf{e}_3$ du rotationnel est non nulle.

︡f65107f8-6b72-4b65-897b-c74839bafa52︡{"done":true,"md":"## Le rotationnel d'un champ de vecteurs\nDéfinition : Étant donné un champ de vecteurs $\\mathbf{F}=P\\mathbf{e}_1+Q\\mathbf{e}_2+R\\mathbf{e}_3$, son rotationnel est le champ de vecteurs $${\\rm rot}\\mathbf{F} = \\nabla \\times\\mathbf{F} = \\left(\\frac{\\partial R }{\\partial y} - \\frac{\\partial Q }{\\partial z }  \\right)\\mathbf{e}_1 + \\left(\\frac{\\partial P }{\\partial z} - \\frac{\\partial R}{\\partial x}  \\right) \\mathbf{e}_2+ \\left(\\frac{\\partial Q}{\\partial x} - \\frac{\\partial P}{\\partial y}  \\right)\\mathbf{e}_3$$\n\nLa signification physique du champ rotationnel est la mesure que $\\mathbf{F}$ aurait à faire tourner des particules, s'il était un champ de vitesses : si $\\mathbf{u}$ est un vecteur donné, le produit scalaire ${\\rm rot}\\mathbf{F}\\cdot\\mathbf{u}$ au point $(x_0,y_0,z_0)$ est la mesure de la tendence à faire des tourbillons autour de l'axe de rotation passant par $(x_0,y_0,z_0)$ de direction $\\mathbf{u}$.  En 3D il est (un peu)  compliqué de visualiser les choses, il convient de commencer par des champs $\\mathbf{F}=P\\mathbf{e}_1+Q\\mathbf{e}_2$, c'est à dire en faisant $R=0$, et $P=P(x,y), Q=Q(x,y)$. Ainsi, seule la coposante $\\mathbf{e}_3$ du rotationnel est non nulle."}
︠807be751-c1d0-4f4e-aa8d-ff4b103c63ads︠
%typeset_mode True
var('x,y,z')
def rot3d(F):
    assert(len(F) == 3)
    return vector([diff(F[2],y)-diff(F[1],z), diff(F[0],z)-diff(F[2],x), diff(F[1],x)-diff(F[0],y)])
︡fb178f22-d950-4303-bb25-d60adedbe33c︡{"html":"<div align='center'>($\\displaystyle x$, $\\displaystyle y$, $\\displaystyle z$)</div>"}︡{"done":true}
︠493125ac-2641-4ad8-86b4-3ccdb8307a81s︠

︡91438606-9b09-4f44-9295-b489fc31d995︡{"done":true}︡
︠e32c61c5-1ebb-414e-b5b3-1e68655d5d19s︠
F=[sin(y),cos(x)]
F3D=[F[0],F[1],0]
k=vector([0,0,1])
cmsel = [colormaps['Greens'](i) for i in sxrange(0,1,0.05)]
Zrot=plot3d(rot3d(F3D).dot_product(k) ,(x,-3*pi/2,3*pi/2),(y,-3*pi/2,3*pi/2),adaptive=True, color=cmsel)
html('Le champ $F$ avec 3 composantes :')
F3D
html('La rotationnel du champ $F$ (vu comme ayant 3 composantes) est')
rot3d(F3D)
︡99d8ae05-289f-42ef-8182-a1baad4b7825︡{"html":"Le champ $F$ avec 3 composantes :"}︡{"html":"<div align='center'>[$\\displaystyle \\sin\\left(y\\right)$, $\\displaystyle \\cos\\left(x\\right)$, $\\displaystyle 0$]</div>"}︡{"html":"La rotationnel du champ $F$ (vu comme ayant 3 composantes) est"}︡{"html":"<div align='center'>$\\displaystyle \\left(0,\\,0,\\,-\\cos\\left(y\\right) - \\sin\\left(x\\right)\\right)$</div>"}︡{"done":true}
︠f959c996-9a27-4131-8c8e-f771bbb4ba03i︠

︡78ac5a0c-1479-4b96-9c1d-3d1adb1db27b︡
︠7bd9f52e-ea1f-4969-8257-a0ea52a9ddaas︠
Champ=plot_vector_field(F,(x,-3*pi/2,3*pi/2),(y,-3*pi/2,3*pi/2),color='blue', ticks=[pi/2,pi/2], tick_formatter=[pi,pi], title = "Champ F")
show(Champ,figsize=7,aspect_ratio=1)
︡a22e33b1-5140-47cf-9625-f31102461878︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/318/tmp_aZlJka.svg","show":true,"text":null,"uuid":"21ce1d78-6db1-4282-a381-c1ac466dcf8a"},"once":false}︡{"done":true}
︠b0c67273-dc88-4cc8-b4a0-f19ae6958c78i︠

︡ec47d767-63b8-485e-991d-4bb4957119e2︡
︠a174501a-0ca6-403e-9a60-39070c4810c2i︠
%md
On voit bien qu'il y a, à certains endroits une tendance à faire un tourbillon. Le rotationnel est non nul en ces points.

- Au point $(\pi/2,0)$ il vaut $-2$, ce qui reflète qu'au tour de ce point le sens du tourbillon est celui des aiguilles d'une montre.
- Au contraire, en $(-\pi/2,\pi)$, la composante du rotationnel est $2$. En ce point, le tourbillon tourne en sens horaire.
- Que se passe-t-il sur les droites $y=x\pm \pi/2$.
- Remarquez que les points les plus hauts de la surface correspondent aux points ou le tourbillon est plus intense dans la figure représentant le champ.
- À l'opposé, les points les plus bas correspondent à un tourbillon "intense" dans le sens horaire.
︡ebf2c37d-8202-4ccb-91d8-316031a4ec6d︡{"done":true,"md":"On voit bien qu'il y a, à certains endroits une tendance à faire un tourbillon. Le rotationnel est non nul en ces points.\n\n- Au point $(\\pi/2,0)$ il vaut $-2$, ce qui reflète qu'au tour de ce point le sens du tourbillon est celui des aiguilles d'une montre.\n- Au contraire, en $(-\\pi/2,\\pi)$, la composante du rotationnel est $2$. En ce point, le tourbillon tourne en sens horaire.\n- Que se passe-t-il sur les droites $y=x\\pm \\pi/2$.\n- Remarquez que les points les plus hauts de la surface correspondent aux points ou le tourbillon est plus intense dans la figure représentant le champ.\n- À l'opposé, les points les plus bas correspondent à un tourbillon \"intense\" dans le sens horaire."}
︠3a89c675-6c02-4a2b-bea4-c632ac512a1cs︠
html('La surface ayant pour équation z = ')
rot3d(F3D).dot_product(k)
show(Zrot,aspect_ratio=1)
︡db7e2b30-0df9-4a60-aeea-0056b6066b65︡{"html":"La surface ayant pour équation z = "}︡{"html":"<div align='center'>$\\displaystyle -\\cos\\left(y\\right) - \\sin\\left(x\\right)$</div>"}︡{"file":{"filename":"47d527b2-5503-441b-b87c-6a629eb0acd3.sage3d","uuid":"47d527b2-5503-441b-b87c-6a629eb0acd3"}}︡{"done":true}
︠ed900203-f0b2-4f85-b57f-5a0fe9f92243s︠
rot3d(F3D).dot_product(k)
︡0d969245-9a77-457c-8360-e6ab3c77226b︡{"html":"<div align='center'>$\\displaystyle -\\cos\\left(y\\right) - \\sin\\left(x\\right)$</div>"}︡{"done":true}
︠29083d42-dd76-4e97-a133-e7d9a40beb3bi︠
%md
## Remarquez la valeur du rotationnel (plus la couleur verte est foncée, plus la valeur (de la composante $z$) du rotationnel est élevée)). Comparez avec la propension à faire des tourbillons.
︡a66ca4d1-4e67-4ae2-a699-ed669ab5802a︡{"done":true,"md":"## Remarquez la valeur du rotationnel (plus la couleur verte est foncée, plus la valeur (de la composante $z$) du rotationnel est élevée)). Comparez avec la propension à faire des tourbillons."}
︠9815de73-5ef7-4c4e-9815-36f8b42f01a8s︠
Champ=plot_vector_field(F,(x,-3*pi/2,3*pi/2),(y,-3*pi/2,3*pi/2),color='blue', ticks=[pi/2,pi/2], tick_formatter=[pi,pi], title = "Champ F")

Zrot2d  = contour_plot(rot3d(F3D).dot_product(k) ,(x,-3*pi/2,3*pi/2),(y,-3*pi/2,3*pi/2), cmap= "Greens", fill = True, colorbar = True, labels = False, contours = 15)
show(Champ,figsize=6,aspect_ratio=1)
show(Zrot2d,figsize=6,aspect_ratio=1)
︡41f7a1d6-db7a-44f0-8786-dd2e83304ae8︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/318/tmp_4CT846.svg","show":true,"text":null,"uuid":"b4ed952d-36ab-4c32-a045-454bf84962a9"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/318/tmp_1DSDmr.svg","show":true,"text":null,"uuid":"de06e1fe-9dd7-42af-b424-9e5e16206cd3"},"once":false}︡{"done":true}
︠978da1bc-d270-4f64-a456-34fa88b7ba54︠










